#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_debug_info4xi.py">
#<abstract4xi abstract = "tests debug_info4xi"/>
#<verify4xi verification = "10" target = "debug_info4xi.py"/>
#<contextualize4xi context = "array4xi.py; syncmanager4xi.py; token4xi.py; server4xi.py; manager4xi.py; authenticationstring4xi.py; popen4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_debug_info4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading
import array
import _winapi

# -------------------------------------------------------------------------------------------------
# conditional imports                              
# -------------------------------------------------------------------------------------------------
try:
    from cPickle import PicklingError
except ImportError:
    from pickle import PicklingError
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from array4xi import Array4Xi
from authenticationstring4xi import AuthenticationString4Xi

from constant_family4xi import get_default_family4xi

from debug_info4xi import debug_info4xi

from listener_client4xi import listener_client4xi
from lock4xi import Lock4Xi

from manager4xi import Manager4Xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      
from popen4xi import Popen4Xi
from print4xi import Print4Xi

from rlock4xi import RLock4Xi

from server4xi import Server4Xi
from syncmanager4xi import SyncManager4Xi

from time4xi import time4xi
from token4xi import Token4Xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    __all__ = [ 'debug_info4xi'] 
    
    KB4Tailoring = {
        'Client4Xi': 'NACK4TRACE',               # OK
        'debug_info4xi': 'NACK4TRACE',     # OK
        'listener_client4xi': 'NACK4TRACE',      # OK
        'Array4Xi': 'NACK4TRACE',                # OK
        'SyncManager4Xi': 'NACK4TRACE',          # OK
        'Token4Xi': 'NACK4TRACE',                # OK
        'Server4Xi': 'NACK4TRACE',               # OK
        'Manager4Xi': 'NACK4TRACE',              # OK
        'pickle4xi': 'NACK4TRACE',               # OK
        'AuthenticationString4Xi': 'NACK4TRACE', # OK
        'Popen4Xi': 'NACK4TRACE',                # OK
        'Listener4Xi': 'NACK4TRACE',             # OK
        'Lock4Xi': 'NACK4TRACE'                  # OK
        }                             

                        
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Array4Xi
        # AuthenticationString4Xi
        # Lock4Xi
        # Manager4Xi
        # Popen4Xi
        # Server4Xi
        # SyncManager4Xi
        # Token4Xi
        # debug_info4xi
        # listener_client4xi
        # pickle4xi
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING:  ", time4xi())
    #

    
#</function4xi>       

             
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-debug-info4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing debug info in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for converting errors.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-debug-info4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for debug info in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations debug info in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-debug-info4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for debug info in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for debug info in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "func2xi" usage = "
#   Python functions can have keyword-only arguments listed after the * parameter and before the ** paramter if any, e.g.
#   def f(a, b, *args, c, d = 42, e, **kwds):
#                 e c, d and e cannot be passed as position arguments and must be passed as keyword arguments
#                 c and e are required keyword arguments, since they do not have a default value
#   if the parameter name after the * is omitted, the function will not accept any extra positional arguments
#   def g(a, b, *, c, d): ...takes exactly two positional parameters and has two required keyword parameters
#   
#">                       
# -------------------------------------------------------------------------------------------------  
def func2xi(token, serializer, incref, **kwds):

    return True

#</function4xi>     

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test" usage = "
#   test
# -------------------------------------------------------------------------------------------------    
def test(obj):
    
    # ---------------------------------------------------------------------------------------------
    # Information about the module
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ", time4xi())
    print("\n test_debug_info4xi ", time4xi())
    
    # ---------------------------------------------------------------------------------------------
    # All methods of this object
    # ---------------------------------------------------------------------------------------------
    print("\n debug_info4xi all methods: ", all_methods4xi(obj))
   

    # ---------------------------------------------------------------------------------------------
    # Methods compatible with multiprocessing
    # ---------------------------------------------------------------------------------------------
    #print("\n : ", obj.()) <--- copy and paste to test the methods returning something
    

    
    
    # ---------------------------------------------------------------------------------------------
    # Methods added by DragonXi
    # ---------------------------------------------------------------------------------------------
    print("\n sense: ", obj.sense())
    print("\n reason: ", obj.reason())
    print("\n ace: ", obj.ace())

    # ---------------------------------------------------------------------------------------------
    # End of test
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ", time4xi())

#</function4xi>    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_debug_info4xi" usage = "
#   testing debug info
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_debug_info4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0/33) OF TEST_DEBUG_INFO4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:    

        # ---------------------------------------------------------------------------------------------
        # token2xi object
        # --------------------------------------------------------------------------------------------- 
        typeid2xi = "ip"
        address2xi = ('localhost', 8080)
        id2xi = "yourdragonxi.com"
        token2xi = Token4Xi(typeid2xi, address2xi, id2xi)
    
        debug_info4xi(token2xi)
        # Token4Xi(typeid='ip', address=('localhost', 8080), id='yourdragonxi.com'); time: 05:32:24 02/12/13 Pacific Standard Time
        
        # ---------------------------------------------------------------------------------------------
        # communication objects
        # ---------------------------------------------------------------------------------------------
        registry2xi =  {}
        authkey2xi = os.urandom(32)
        serializer2xi='pickle'
        # server2xi = Server4Xi(registry2xi, address2xi, authkey2xi, serializer2xi)
        server2xi = None 
        debug_info4xi("skipped creating server because it loops forever")
        
        # ---------------------------------------------------------------------------------------------
        # manager objects
        # ---------------------------------------------------------------------------------------------
        manager2xi = Manager4Xi()
        debug_info4xi(manager2xi)
        
        # ---------------------------------------------------------------------------------------------
        # misc objects
        # ---------------------------------------------------------------------------------------------
        exposed2xi=('sense', 'reason', 'ace')
        incref2xi=True
        cache2xi={}
        s2xi = 'AutoProxyXi'
        name2xi = 'AutoProxy[%s2xi]'
        lock2xi = Lock4Xi()
        
        debug_info4xi(lock2xi)
        
        # ---------------------------------------------------------------------------------------------
        # Array
        # Type code C Type Python Type Minimum size in bytes 
        # 'c' char character 1 
        # 'b' signed char int 1 
        # 'B' unsigned char int 1 
        # 'u' Py_UNICODE Unicode character 2 
        # 'h' signed short int 2 
        # 'H' unsigned short int 2 
        # 'i' signed int int 2 
        # 'I' unsigned int long 2 
        # 'l' signed long int 4 
        # 'L' unsigned long long 4 
        # 'f' float float 4 
        # 'd' double float 8 
        # ---------------------------------------------------------------------------------------------
        typecode2xi = 'u'
        sequence2xi = []
        
        # ---------------------------------------------------------------------------------------------
        # building keywords
        # ---------------------------------------------------------------------------------------------
        kwds2xi = {}
        #kwds2xi['authkey'] = authkey2xi
        kwds2xi['incref'] = True
    
        # ---------------------------------------------------------------------------------------------
        # arrays tested
        # ---------------------------------------------------------------------------------------------    
        au = "\N{GREEK CAPITAL LETTER DELTA}"  
        bu = "\u0394"
        cu = "\U00000394"
        creekarray2xi = [au, bu, cu]
        
        # ---------------------------------------------------------------------------------------------
        #
        # ---------------------------------------------------------------------------------------------
        
        sequence2xi = creekarray2xi
        xi2a = Array4Xi(typecode2xi, sequence2xi, lock2xi)
        
        # debug_info4xi(xi2a) <-- do NOT try this!
             
        # ---------------------------------------------------------------------------------------------
        # pass the tests if the object such as a server would start an infinite loop
        # ---------------------------------------------------------------------------------------------
    
        listener2xi, client2xi = listener_client4xi[serializer2xi]
        
        debug_info4xi(listener2xi)
        
        debug_info4xi(client2xi)
    
        
    # -----------------------------------------------------------------------------------------    
    # 
    # ----------------------------------------------------------------------------------------- 
    except:
        print("(Step 7Z/33) OF TEST-DEBUG_INFO4XI *** FAILED TESTING TEST_DEBUG_INFO4XI ***  ", time4xi())  
        

    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print("(Step 8A/33) OF TEST-DEBUG_INFO4XISTEP - PASSING TO PRINT_TRACE4XI TRACE OBJECT: ", t2xi)        
        # <print4xi.Print4Xi object at 0x0000000002A2AF28>
        
        print_trace4xi(t2xi)        
           
        # ---------------------------------------------------------------------------------------------    
        # 
        # ---------------------------------------------------------------------------------------------         
        print("(Step 8B/33) OF TEST-DEBUG_INFO4XISTEP - COMPLETED TESTING TEST_DEBUG_INFO4XI!   ", time4xi())               
        # 05:38:14 02/12/13 Pacific Standard Time         
#</function4xi>  
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test debug info
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("STEP: SENSING DEBUG INFO WITH YOURDRAGONXI!  ", time4xi())  
    print('=' *33)
    # 
        
    test_debug_info4xi()  
    
    print('=' *33)
    print("STEP: SENSED DEBUG INFO WITH YOURDRAGONXI!  ", time4xi())    
    print('=' *33) 
    # 
                      
#</function4xi>

    
   
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()    
    

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_debug_info4xi.txt

#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_debug_info4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

